<?php

function GetExtension($fichier)
{
	$pos = strrpos($fichier, ".");
	$extension = substr($fichier, $pos + 1, strlen($fichier) - $pos);
	// echo $fichier." - ".$pos." ".$extension."<br>";
	return $extension;
}

function GetRoot($fichier)
{
	$pos = strrpos($fichier,".");
	if ($pos) {
		$extension = substr($fichier,0,$pos);
		return $extension;
	}
	return $fichier;
}

function fgets_u($pStdn) {
	$pArr = array($pStdn);

    if (false === ($num_changed_streams = stream_select($pArr, $write = NULL, $except = NULL, 0))) {
       print("\$ 001 Socket Error : UNABLE TO WATCH STDIN.\n");
       return FALSE;
    } elseif ($num_changed_streams > 0) {
       return trim(fgets($pStdn, 4096));
    }
}


function get_sortType($sortType)
{
	if ($sortType == 'MODNAME') {
		return "MODNAME";
	} else if ($sortType == 'MODFILE') {
		return "MODFILE";
	} else if ($sortType == 'MODCAT') {
		return "MODCAT";
	} else if ($sortType == 'MODTYPE') {
		return "MODTYPE";
	} else if ($sortType == 'MODDIR') {
		return "MODDIR";
	} else {
		return "MODNAME";
	}
}

function RemoveBadEndChars($string)
{
	$i = strlen($string)-1;
	while (ord($string[$i]) < 33) {
		$i--;
	}
	$string = substr($string,0,$i+1);
	return $string;
}

function GetMODVersion($path)
{
	//echo "<br>$path";
	$res = GetTagFromHtml($path, "MODVERSION:");
	if ($res != FALSE) {
		return $res;
	}
	if (file_exists($path)) {
		//echo "<br>OK!";
		$fp = fopen($path, "rb"); // le fichier existe, on l ouvre
		if ($fp == -1) {
			return false;
		}
		$foundTD = 0;
		$foundVer = 0;
		while (!feof($fp)) { // On parcours le fichier
			$line = fgets($fp, 4096);
			$iStartVer = 0;
			if ( ($foundVer == 0) && (strpos($line,"Version :")!==FALSE)) {
				$foundVer = 1;
				$iStartVer = strpos($line,"Version :");
				//echo "<br>Found Version!";
			}
			if ( ($foundVer == 0) && (strpos($line,"Version:")!==FALSE)) {
				$foundVer = 1;
				$iStartVer = strpos($line,"Version:");
				//echo "<br>Found Version!";
			}

			if ($foundVer == 1)  { // when version found, search "<td" after "Version :"
				$iStartTD = 0;
				$subLine = substr($line,$iStartVer,strlen($line));
				if (($foundTD == 0) && strpos(strtolower($subLine),"<td")) {
					$foundTD = 1;
					$iStartTD = strpos($subLine,"<TD");
					//echo "<br>Found TD!";
				}
				if ($foundTD == 1) {
					$subLine2 = substr($subLine,$iStartTD,strlen($subLine));
					if (ereg("([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{1,2})", $subLine2, $regs)) { // problem : warning while considering more than 2 numbers
						//print_r($regs);
					   	fclose($fp); // Fermeture du fichier
					   	return $regs[0];
					}
				}
			}
		}
		fclose($fp); // Fermeture du fichier
	}
	return FALSE;
}

function GetNameFromHtml($path)
{
	$res = GetTagFromHtml($path, "MODNAME:");
	if ($res != FALSE) {
		return $res;
	}

	if (file_exists($path)) {
		$fp = fopen($path, "rb"); // le fichier existe, on l ouvre
		$foundTD = 0;
		$foundName = 0;
		if ($fp == -1)
			return false;
		while (!feof($fp)) { // On parcours le fichier
			$line = fgets($fp, 4096);
			$iStartName = 0;
			
			if ( ($foundName == 0) && (strpos($line,"Name :")) !== FALSE) {
				$foundName = 1;
				$iStartName = strpos($line,"Name :");
				//echo "<br>Found Name!";
				//echo "<br>LINE:$line";
			}
			if ( ($foundName == 0) && (strpos($line,"Name:")) !== FALSE) {
				$foundName = 1;
				$iStartName = strpos($line,"Name:");
				//echo "<br>Found Name!";
				//echo "<br>LINE:$line";
			}
			/*
			if ( ($foundName == 0) && (strpos($line,"MODNAME:")) !== FALSE) {
				$foundName = 1;
				$iStartName = strpos($line,"MODNAME:");
				echo "<br>Found Name!";
				echo "<br>LINE:".$iStartName;
			}
			*/
			if ($foundName == 1)  { // when version found, search "<TD" after "Name :"
				$iStartTD = 0;
				// echo "<br>line with name:$line";
				if (($foundTD == 0) && (strpos(strtolower($line),"<td",$iStartName))!==FALSE) {
					$foundTD = 1;
					$iStartTD = strpos(strtolower($line),"<td",$iStartName);
					// echo "<br>Found TD!";
				}
				if ($foundTD == 1) {
					$iStart = $iStartName+$iStartTD;
					while ( $iStart<strlen($line)-1) {
						if ($line[$iStart]===">" && $line[$iStart+1]!=="<" ) {
							if (strpos($line,"<",$iStart+1)===FALSE) {
								// end of name not on same line
								$name = substr($line,$iStart+1,strlen($line)-($iStart+1)-2);
								//echo "<br>NAME of FIRST LINE:$name";
								$line = fgets($fp, 4096);
								$ii = 0;
								while ($line[$ii] === " ") {
									$ii++;
								}
								$iEnd = strpos($line,"<",$ii)-1;
								$name2 = substr($line,$ii,$iEnd-$ii+1);
								//echo "<br>NAME of SECOND LINE:$name2";
								$name3 = $name . " " . $name2;
								return $name3;
							}
							$iEnd = strpos($line,"<",$iStart+1);
							$name = substr($line,$iStart+1,($iEnd-1)-($iStart+1)+1);
							//echo "<br>NAME:$name";
							fclose($fp);
							return $name;
						}
						$iStart++;
					}
				}
			}
		}
		fclose($fp); // Fermeture du fichier
	}
	return FALSE;
}

function GetTagFromHtml($path, $tag)
{
	if (file_exists($path)) {
		$fp = fopen($path, "rb"); // le fichier existe, on l ouvre
		$foundTD = 0;
		$foundName = 0;
		if ($fp == -1)
			return false;
		while (!feof($fp)) { // On parcours le fichier
			$line = fgets($fp, 4096);
			$iStartName = 0;
			
			$starttag = "<!-- ".$tag;
			if ( ($foundName == 0) && (strpos($line, $starttag)) !== FALSE) {
				$foundName = 1;
				$iStartName = strpos($line, $starttag);
				//echo "<br>Found Name!";
				//echo "<br>LINE:".$iStartName;
			}

			if ($foundName == 1)  { // Tag name is found
				$iEndName = strpos($line, "-->");
				//echo "End Tag".$iEndName;
				if ($iEndName > 0)  {
					$name = substr($line, $iStartName + strlen($starttag), $iEndName - $iStartName - strlen($starttag));
					fclose($fp); // Fermeture du fichier
					return trim($name);

				}
				fclose($fp); // Fermeture du fichier
				return FALSE;
			}
		}
		fclose($fp); // Fermeture du fichier
	}
	return FALSE;
}

function GetTagFromInfo($path, $tag)
{
	if (file_exists($path)) {
		$fp = fopen($path, "rb"); // le fichier existe, on l ouvre
		$foundTD = 0;
		$foundName = 0;
		if ($fp == -1)
			return false;
		while (!feof($fp)) { // On parcours le fichier
			$line = fgets($fp, 4096);
			$iStartName = 0;
			
			$starttag = "<".$tag.">:";
			if ( ($foundName == 0) && (strpos($line, $starttag)) !== FALSE) {
				$foundName = 1;
				$iStartName = strpos($line, $starttag);
				// echo "<br>Found Name!";
				//echo "<br>LINE:".$iStartName;
			}

			if ($foundName == 1)  { // Tag name is found
				$iEndName = strpos($line, "\r");
				// echo "End Tag".$iEndName;
				if ($iEndName > 0)  {
					$name = substr($line, $iStartName + strlen($starttag), $iEndName - $iStartName - strlen($starttag));
					fclose($fp); // Fermeture du fichier
					return trim($name);
				} 

				$name = substr($line, $iStartName + strlen($starttag));
				fclose($fp); // Fermeture du fichier
				return trim($name);
			}
		}
		fclose($fp); // Fermeture du fichier
	}
	return FALSE;
}

function GetTypeFromHtml($path)
{
	$res = GetTagFromHtml($path, "MODTYPE:");
	if ($res != FALSE) {
		return $res;
	}

	if (file_exists($path)) {
		$fp = fopen($path, "rb"); // le fichier existe, on l ouvre
		if ($fp == -1)
			return false;
		while (!feof($fp)) { // On parcours le fichier
			$line = fgets($fp, 4096);
			if ( (strpos($line,"<!-- MODTYPE:"))!==FALSE && (strpos($line," -->"))!==FALSE) {
				//echo "<br>line:$line";
				$iStartTYPE = strpos($line,"<!-- MODTYPE:")+13;
				$iEndTYPE   = strpos($line," -->");
				//echo "<br>$iStartTYPE : $iEndTYPE";
				$typeName = substr($line,$iStartTYPE,$iEndTYPE-$iStartTYPE+1);
				//echo "<br>typeName:$typeName";
				fclose($fp);
				return $typeName;
			}
		}
		fclose($fp); // Fermeture du fichier
	}
	return FALSE;
}

function compare($a, $b)
{
   return strcmp($a, $b);
}

function compare_mxm($a, $b)
{
	return strcasecmp($a["MODNAME"],$b["MODNAME"]);
}

function GetDownloadParam($argv,$argc)
{
	//print_r($argv);
	for ($ii = 1; $ii < $argc; $ii++) {
		if (!strcasecmp($argv[$ii],"download")) {
			return 1;
		}
	}
	return 0;
}

function GetAlphaParam($argv,$argc)
{
	// print_r($argv);
	for ($ii = 1; $ii < $argc; $ii++) {
		if (!strcasecmp($argv[$ii],"alpha")) {
			return 1;
		}
	}
	return 0;
}

function GetPathWebParam($argv,$argc)
{
	//print_r($argv);
	for ($ii = 1; $ii < $argc; $ii++) {
		if (!strcasecmp($argv[$ii],"pathweb")) {
			return 1;
		}
	}
	return 0;
}

?>
